package com.example.tolucagraphics.events

data class Events (
    val type: String? = null,
    val command: String? = null,
    val data: Data? = null
)

data class Data (
    val eventName: String? = null,
    val user: UserUser? = null,
    val message: String? = null,
    val room: Room? = null,
    val rooms: Array<Room>? = null
) {
    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (javaClass != other?.javaClass) return false

        other as Data

        if (eventName != other.eventName) return false
        if (user != other.user) return false
        if (rooms != null) {
            if (other.rooms == null) return false
            if (!rooms.contentEquals(other.rooms)) return false
        } else if (other.rooms != null) return false

        return true
    }

    override fun hashCode(): Int {
        var result = eventName?.hashCode() ?: 0
        result = 31 * result + (user?.hashCode() ?: 0)
        result = 31 * result + (rooms?.contentHashCode() ?: 0)
        return result
    }
}

data class Room (
    val id: String? = null,
    val name: String? = null,
    val users: List<UserElement>? = null,
    val tables: List<Any?>? = null
)

data class UserElement (
    val user: UserUser? = null,
    val online: Boolean? = null
)

data class UserUser (
    val id: String? = null,
    val username: String? = null
)